--https://gist.github.com/2bt/3627374
local graphics = love.graphics

dsx = {}
dsy = {}

local setcanvas,draw,clear = love.graphics.setCanvas, love.graphics.draw, love.graphics.clear
local ScrW, ScrH = love.graphics.getWidth, love.graphics.getHeight

local function makestr(d)
	return "$"..tostring(d)
end

local bsx = 0.01
local bsy = 0.01

local dsxs = love.graphics.newShader([[	//shader from googlz
	vec4 effect(vec4 color, Image texture, vec2 vTexCoord, vec2 pixel_coords)
	{
		vec4 sum = vec4(0.0);
		number blurSize = ]]..bsx..[[;
		sum += texture2D(texture, vec2(vTexCoord.x - 4.0*blurSize, vTexCoord.y)) * 0.05;
		sum += texture2D(texture, vec2(vTexCoord.x - 3.0*blurSize, vTexCoord.y)) * 0.09;
		sum += texture2D(texture, vec2(vTexCoord.x - 2.0*blurSize, vTexCoord.y)) * 0.12;
		sum += texture2D(texture, vec2(vTexCoord.x - blurSize, vTexCoord.y)) * 0.15;
		sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y)) * 0.16;
		sum += texture2D(texture, vec2(vTexCoord.x + blurSize, vTexCoord.y)) * 0.15;
		sum += texture2D(texture, vec2(vTexCoord.x + 2.0*blurSize, vTexCoord.y)) * 0.12;
		sum += texture2D(texture, vec2(vTexCoord.x + 3.0*blurSize, vTexCoord.y)) * 0.09;
		sum += texture2D(texture, vec2(vTexCoord.x + 4.0*blurSize, vTexCoord.y)) * 0.05;
		
		return sum;
	}
	]])

local dsys = love.graphics.newShader([[
	vec4 effect(vec4 color, Image texture, vec2 vTexCoord, vec2 pixel_coords)
	{
		vec4 sum = vec4(0.0);
		number blurSize = ]]..bsy..[[;

		sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y - 4.0*blurSize)) * 0.05;
		sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y - 3.0*blurSize)) * 0.09;
		sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y - 2.0*blurSize)) * 0.12;
		sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y- blurSize)) * 0.15;
		sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y)) * 0.16;
		sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y + blurSize)) * 0.15;
		sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y + 2.0*blurSize)) * 0.12;
		sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y + 3.0*blurSize)) * 0.09;
		sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y + 4.0*blurSize)) * 0.05;

		return sum;
	}
	]])


local push, pop = love.graphics.push, love.graphics.pop
local translate = love.graphics.translate
local circ = love.graphics.circle

function shade(tbl,d,bx,by)
	d = (math.floor(d*100)/40)*3
	local dS = makestr(d)

	local l = math.ceil(tbl.s+d*2)*2
	local l2 = l/2
	tbl.l2 = l
	local bcvx = bx or love.graphics.newCanvas(l,l)
	local bcvy = by or love.graphics.newCanvas(l,l)

	--love.graphics.setColor(255,255,255,120)

	push()
	 translate(l2,l2)
		setcanvas(bcvy)
		clear()
	    --love.graphics.setShader(dsx[dS])
	    --love.graphics.setShader(dsx[dS])

	    love.graphics.setColor(60,60,60,255)
	    circ("fill",0,0,tbl.s,(1+tbl.s)*math.pi*2)
    pop()

    for i = 1, d do
	    setcanvas(bcvx)
		    --love.graphics.setShader(dsy[dS])
		    love.graphics.setShader(dsys)
		    draw(bcvy)
		    love.graphics.setShader()

	    setcanvas(bcvy)
		    --love.graphics.setShader(dsx[dS])
		    love.graphics.setShader(dsxs)
		    draw(bcvx)
		    love.graphics.setShader()
	end
	--love.graphics.setBlendMode("add")
	--    circ("line",0,0,tbl.s,tbl.s*math.pi*2)
	 --   love.graphics.setShader()


    if lcvs then setcanvas(lcvs) else setcanvas() end

    return bcvy
end