local cx,cy = math.random(-100,100)/10000,math.random(-100,100)/10000

local tile_size = 42
local line_it = 8
local line_len = 12
local ts2 = tile_size/2

local part = {}

local ScrW, ScrH = love.graphics.getWidth, love.graphics.getHeight
local time = love.timer.getTime

local addVel
local sin,cos,pi2,pi = math.sin, math.cos, math.pi*2, math.pi
local asin,acos,atan2,pi4 = math.asin, math.acos, math.atan2, math.pi*4
local rx,ry = math.random(-1000000,1000000)/1000,math.random(-1000000,1000000)/1000

local blur = require("blur")


--[[local kq = {	--maybe l8er
	["m"] = true,
	["x"] = true,
	["y"] = true,
	["s"] = true,
}


function writeornot(tbl,k,v,p)
	if kq[k] and math.random(0,100) <= p then
		tbl[k] = v
		return true
	end
	return false
end

function merge(into,from)
	for k,v in pairs(from) do
		if type(v) == "table" then
			if into[k] then
				if type(v) == type(into[k]) then
					merge(into[k],v)
				else
					if writeornot(into,k,{},70) then merge(into[k],v) end
				end
			end
			
		else
			writeornot(into,k,v,50)
		end
	end
end]]


------------------------------------------------
-----------------SPAWN:-------------------------
------------------------------------------------

function spawn(tbl,tbl2)
	local new
	if tbl2 then
		new = tbl2
	else
		new = {
			x = math.random(ScrW()),	--pos
			y = math.random(ScrH()),

			r = 0,	--rot

			ax = 0,	--accel
			ay = 0,

			ax2 = 0,	--local stream accel
			ay2 = 0,

			vx = 0,		--vel
			vy = 0,

			lpos = {},	--last positions
			li = 1,	--index offset

			cr = math.random(255),	--color
			cg = math.random(255),
			cb = math.random(255),

			ccs = math.random(42,94)/20,	--color change speed

			f = 0,	--1 = 100% search, 0 = 100% passive
			lf = 0,
			df = math.random(2000)/1000,	--desired f

			rti = time() + math.random(5000)/1000, --think interval

			t = 0,
		}

		new.af = 1-new.f

		new.m = ( math.random(1800,math.random(2000,3800))/1000 )^2	--mass
		new.s = 0.25 + 1 / new.m 	--speed

		new.cr = (sin(new.m*pi)+1)/2*255	--color #2
		new.cg = (sin(new.m*pi+pi/2)+1)/2*255
		new.cb = (sin(new.m*pi+pi)+1)/2*255
	end
	
	new.sx = 5+new.m*3
	new.sy = new.sx
	new.d = ((new.sx^2)+(new.sy^2))^2

	--if tbl then merge(new,tbl) end

	table.insert(part, new)
end

for I = 1, 8 do --spawn 8 fish
	spawn()
end

local deb = {}	--background particles
for i = 1, 500 do
	local new = {
		x = math.random(ScrW()),
		y = math.random(ScrH()),
		vx = 0,
		vy = 0,
		s = (math.random(330,880)/100)^2	--size (radius)
	}

	table.insert(deb, new)

	new.d = new.s/10 + math.floor(math.random(80,280)/120)^2	--blur iterations

end

--[[local qk = {}
function queue_kill(p)
	table.insert(qk,p)
end

function kill(p)
	for i,v in ipairs(part) do
		if v == p then
			table.remove(part,i)
			break
		end
	end

	local rnd = math.random(1,#part)
	local rnd2 = math.random(1,#part)
	spawn(part[rnd],part[rnd2])
end]]

local function sign(x)
	return x > 0 and 1 or (x < 0 and -1 or 0)
end

--noise(pos_x,pos_y) = vel_x,vel_y,vel_ang_heading
local function noise(x,y) 
	local mag = math.min((cx^2+cy^2)^0.5,0)

	local ngx,ngy = (x%ScrW()+1)/1200+rx,(y%ScrH()+1)/1200+ry

	local n = (love.math.noise(ngx,ngy)^0.5)*pi4*1.5+pi

	local ax,ay,dx,dy,dd = 0,0,0,0,0
	local c = #part
	for i,p in ipairs(part) do

		dx = (x-p.x)
		dy = (y-p.y)
		dd = ((dx^2)+(dy^2))^0.5
		if dd < p.m*20 then
			local dor = ((dx*p.vx)+(dy*p.vy))/dd
			dd=math.max((dd^2),0.0000001)/5

			ax = ax+((p.m*dx)/dd)
			ay = ay+((p.m*dy)/dd)
		end
	end

	x,y = cos(n)*2-cx*15+ax,sin(n)*2-cy*15+ay
	local nxy = (x^2+y^2)^0.5

	return x,y, atan2(x,y)
end

------------------------------------------------
-----------------CALC:--------------------------
------------------------------------------------


do

	local f = 10	--force multiplier

	function addVel(p,dt)	--swim little fishy
		local nx,ny,nr = noise( p.x , p.y )
		local vel = ((p.vx^2)+(p.vy^2))^0.5

		--pre-brain:
		local mx,my = (nx*p.af)/p.s+((p.ax2+p.ax*p.m/2000)*p.f)*p.s,(ny*p.af)/p.s+((p.ay2+p.ay*p.m/2000)*p.f)*p.s

		--forces:
		p.ax = (mx*f/p.m)
		p.ay = (my*f/p.m)

		p.vx = p.vx + p.ax
		p.vy = p.vy + p.ay

		p.vx = p.vx*(0.977+0.023/p.m)
		p.vy = p.vy*(0.977+0.023/p.m)

		p.r = math.atan((p.ay+p.vy)/(p.ax+p.vx))


		--fish-brain:
		if p.df < p.f then
			p.f = p.f + (p.df-p.f)/p.m*dt*5
			p.af = 1-p.f
		elseif p.df > p.f then
			p.f = p.f + (p.df-p.f)/p.m*dt*5
			p.af = math.max(1-p.f,0)
		end

		if p.rti < time() then
			p.rti = time() + math.random(400,1750)/1000
			local vel = (p.vx^2+p.vy^2)^0.5
			p.lf = p.df
			if vel < 300 then
				p.df = 0.8
			elseif vel > 300 and vel < 500 then 
				p.df = 0.2
			else
				p.df = (math.random(1500)/1000)
			end
			
			p.af = 1-p.f
		end
	end
end

local drag_x,drag_y = 0,0
local drag = false

function love.update(dt)
	--drag:
	if drag and not love.mouse.isDown(1) then
		drag = false
	elseif not drag and love.mouse.isDown(1)then
		drag = true
		drag_x = love.mouse.getX()
		drag_y = love.mouse.getY()
	end


	for k,v in ipairs(part) do --update fish
		addVel(v,dt)

		v.lpos[v.li] = {v.x,v.y,v.r,v.cr,v.cg,v.cb}
		v.li = v.li + 1
		if v.li > 20 then v.li = 1 end

		v.x = v.x + v.vx*dt
		v.y = v.y + v.vy*dt

		--handle screen clipping
		if v.x > ScrW() then v.x = v.x - ScrW() end
		if v.y > ScrH() then v.y = v.y - ScrH() end

		if v.x < 0 then v.x = ScrW() - v.x end
		if v.y < 0 then v.y = ScrH() - v.y end
	end
	--[[while qk[1] ~= nil do
		kill(table.remove(qk,1))
	end]]

	for k,v in ipairs(deb) do 	--update particle
		local Nx,Ny = noise( v.x , v.y )

		v.vx  = v.vx + Nx*200
		v.vy  = v.vy + Ny*200

		v.vx  = v.vx * 0.99
		v.vy  = v.vy * 0.99

		v.x  = v.x + v.vx*dt/(v.s+v.d)^2
		v.y  = v.y + v.vy*dt/(v.s+v.d)^2

		if v.x > ScrW() then v.x = v.x - ScrW() end
		if v.y > ScrH() then v.y = v.y - ScrH() end

		if v.x < 0 then v.x = ScrW() - v.x end
		if v.y < 0 then v.y = ScrH() - v.y end
	end
end


------------------------------------------------
-----------------DRAW:--------------------------
------------------------------------------------

------------------------------------------------FISH:
local rect = love.graphics.rectangle
local circ = love.graphics.circle
local line = love.graphics.line
local color = love.graphics.setColor
local fill = "fill"
local _line = "line"
local col = {255,160,0,180}

local push, pop = love.graphics.push, love.graphics.pop
local translate, rotate = love.graphics.translate, love.graphics.rotate
local min,max = math.min, math.max
local sin,cos,pi2 = math.sin, math.cos, math.pi*2

local function drawRect(p,x,y,sx,sy,sx2,sy2,dt)
	local Nx,Ny,Nr = noise( x , y )

	local gx,gy = x,y
	color(p.cr,p.cg,p.cb,20)
	local it = math.ceil(10*p.f+1)

	local anG = 0
	for I= 1,it do
		local lx,ly = gx,gy
		local N2x,N2y, N2r = noise( lx , ly )

		local dlf = math.abs(p.f / p.df) * 5

		gx, gy = gx+sin(N2r)*p.m,gy+cos(N2r)*p.m
		
		local det = ((I/it)-0.3)^2+0.4
		local det2 = det / 3

		if I == it then
			p.ax2 = N2x
			p.ay2 = N2y

			local _cr,_cg,_cb = sin(N2r) * 128 + 127,sin(N2r+pi/3) * 128 + 127,sin(N2r+pi*2/3) * 128 + 127

			p.cr = p.cr + ((_cr - p.cr))*dt*p.ccs
			p.cg = p.cg + ((_cg - p.cg))*dt*p.ccs
			p.cb = p.cb + ((_cb - p.cb))*dt*p.ccs

		end

		push()
			translate(lx, ly)
			rotate(pi/2-N2r)
			rect(_line,1-sx2*det,1-sy2*det2,sx*det,sy*det2)
		pop()

	end
	color(p.cr,p.cg,p.cb,20)
	love.graphics.setBlendMode("alpha")

	local rot = Nr

	color(p.cr,p.cg,p.cb,20)
	push()
		
		translate(p.x,p.y)
		rotate(p.r)
		love.graphics.setBlendMode("subtract")
		rect(fill,-sx2-1,-sy2-1,sx+2,sy+2)
		love.graphics.setBlendMode("alpha")
	pop()

	push()
		
		translate(p.x,p.y)
		rotate(p.r)
		color(p.cr,p.cg,p.cb,120)
		rect(fill,-sx2,-sy2,sx,sy)
		love.graphics.setBlendMode("add")
		color(p.cr,p.cg,p.cb,255)
		rect(_line,-sx2,-sy2,sx,sy)
		love.graphics.setBlendMode("alpha")
	pop()
end

function drawtrail(p,sx,sy,sx2,sy2)
	love.graphics.setBlendMode("add")
	for I,pos in ipairs(p.lpos) do
	push()
		translate(pos[1],pos[2])
		rotate(pos[3])
		color(pos[4],pos[5],pos[6],5)
		love.graphics.setBlendMode("add")
		rect(fill,-sx2,-sy2,sx,sy)
		color(pos[4],pos[5],pos[6],80)
		line(-sx2,-sy2,sx2,-sy2)
		line(-sx2,sy2,sx2,sy2)
		love.graphics.setBlendMode("alpha")
	pop()
	end
	love.graphics.setBlendMode("alpha")
end

local pnx,pny = 500,500
local pncvs = love.graphics.newCanvas( pnx,pny )
local pnx2,pny2 = pnx/2,pny/2

local canvas
local setcanvas,draw,clear = love.graphics.setCanvas, love.graphics.draw, love.graphics.clear

local function drawParticle(p,dt)
	local sx2, sy2 = p.sx/2, p.sy/2

	push()
		setcanvas(pncvs)
		clear()
		translate(pnx2-p.x,pny2-p.y)
		color(col)
		drawRect(p, p.x, p.y, p.sx, p.sy, sx2, sy2,dt)
		setcanvas()
	pop()
	color(255,255,255,255)
	love.graphics.setBlendMode("add")
	draw(pncvs,p.x-pnx2, p.y-pnx2)
	if p.x + p.d >= ScrW() then
		draw(pncvs, p.x-pnx2-ScrW(), p.y-pnx2)
	end
	if p.y + p.d >= ScrH() then
		draw(pncvs, p.x-pnx2, p.y-pnx2-ScrH())
	end
	if p.x - p.d <= 0 then
		draw(pncvs, p.x-pnx2+ScrW(), p.y-pnx2)
	end
	if p.y - p.d <= 0 then
		draw(pncvs, p.x-pnx2, p.y-pnx2+ScrH())
	end
	drawtrail(p,p.sx, p.sy, sx2, sy2)
	love.graphics.setBlendMode("alpha")
end
------------------------------------------------
------------------------------------------------


local t = time()

function movecanvas(x,y)
	rx = rx+ x
	ry = ry+ y
	canvas = nil
end

local rnd = math.random
local ecvs = love.graphics.newCanvas(ScrW(),ScrH(),"rgba32f")
local ppcvs = love.graphics.newCanvas(ScrW(),ScrH(),"rgba32f")
local ppcvs2 = love.graphics.newCanvas(ScrW(),ScrH(),"rgba32f")

local bcvx = love.graphics.newCanvas(ScrW(),ScrH(),"rgba32f")
local bcvy = love.graphics.newCanvas(ScrW(),ScrH(),"rgba32f")
local graphics = love.graphics


local init = false
function love.draw()
	------------------------------------------------
	--background
	if not init then
		for k,v in ipairs(deb) do
			if not v.img then v.img = shade(v,v.d) end
		end
		init = true
	end

	dt = time() - t
	t = time()

	color(250,250,250,50)
	love.graphics.setBlendMode("alpha")
	local s2 = 0

	setcanvas(ppcvs)
		clear(0,0,0,255)
		love.graphics.setBlendMode("add")
		color(222,222,222,255)
		draw(ppcvs2)

		love.graphics.setBlendMode("add")
		for k,v in ipairs(deb) do

			local nvx,nvy = noise(v.x,v.y)
			local nvr = atan2(v.vx,v.vy)

			color(sin(nvr) * 255,sin(nvr+pi*2/3) * 255,sin(nvr+pi*4/3) * 255,255)

			draw(v.img,v.x-v.l2,v.y-v.l2)

			if v.x + v.l2 >= ScrW() then
				draw(v.img,v.x-v.l2-ScrW(),v.y-v.l2)
			end
			if v.y + v.l2 >= ScrH() then
				draw(v.img,v.x-v.l2,v.y-v.l2-ScrH())
			end
			if v.x - v.l2 <= 0 then
				draw(v.img,v.x-v.l2+ScrW(),v.y-v.l2)
			end
			if v.y - v.l2 <= 0 then
				draw(v.img,v.x-v.l2,v.y-v.l2+ScrH())
			end
		end
	setcanvas()

	love.graphics.setBlendMode("alpha")

	setcanvas(ppcvs2)
		color(255,255,255,255)
		draw(ppcvs)
	setcanvas()

	love.graphics.setBlendMode("add")
	color(100,100,100,200)
	draw(ppcvs)

	------------------------------------------------
	--arms
	if not canvas then
		canvas = love.graphics.newCanvas( )
		setcanvas(canvas)
		love.graphics.clear( )
		local cxy = (cx^2+cy^2)^0.5*3300+30

		for X = 0,math.ceil(ScrW()/tile_size)-1 do
			for Y = 0,math.ceil(ScrH()/tile_size)-1 do
				local px,py = ((X*tile_size)+ts2), ((Y*tile_size)+ts2)
				local Nx,Ny,Nr = noise( px , py )

				color(sin(Nr) * 200 + 55,sin(Nr+pi*2/3) * 200 + 55,sin(Nr+pi*4/3) * 200 + 55,24)
				rect(fill,px-2,py-2,4,4)


				local gx, gy = px+Nx*(line_len+math.random(-cxy,cxy)/100),py+Ny*(line_len+math.random(-cxy,cxy)/100)
				if (Nx^2+Ny^2)^0.5 < 4 then
					love.graphics.setBlendMode("alpha")
					line(gx, gy,px,py)
					for I= 1, rnd(line_it*0.67,line_it) do
						local lx,ly = gx,gy
						local N2x,N2y,N2r = noise( lx , ly )
						if (N2x^2+N2y^2)^0.5 > 10 then break end
						color(sin(N2r) * 128 + 127,sin(N2r+pi*2/3) * 128 + 127,sin(N2r+pi*4/3) * 128 + 127,24)
						gx, gy = gx+N2x*(line_len+math.random(-cxy,cxy)/100),gy+N2y*(line_len+math.random(-cxy,cxy)/100)
						line(lx, ly,gx,gy)
					end
					love.graphics.setBlendMode("alpha")
				end
			end
		end
		setcanvas()
	end

	--+++++++++
	--+effects:
	local dis = 1.5
	love.graphics.setBlendMode("alpha")
	if canvas then
		setcanvas(ecvs)
			clear()

			color(255,255,255,255)
			draw(canvas)
			love.graphics.setBlendMode("add")
			

			color(255,255,255,255)
			draw(canvas,0,dis)
			draw(canvas,0,-dis)

			draw(canvas,dis,0)
			draw(canvas,-dis,0)

		setcanvas()
		love.graphics.setBlendMode("alpha")
		color(255,255,255,255)
		draw(ecvs)

		love.graphics.setBlendMode("add")

		color(255,255,255,255)
		draw(ecvs,0,dis)
		draw(ecvs,0,-dis)

		draw(ecvs,dis,0)
		draw(ecvs,-dis,0)


		--draging:
		
		if drag then
			cx = -(love.mouse.getX()-drag_x)/ScrW()
			cy = -(love.mouse.getY()-drag_y)/ScrH()
			drag_x = love.mouse.getX()
			drag_y = love.mouse.getY()
			movecanvas(cx,cy)
		else
			movecanvas(cx/6,cy/6)
		end
	end

	------------------------------------------------

	love.graphics.setBlendMode("alpha")

	for k,v in ipairs(part) do
		drawParticle(v,dt)
	end
end
